/******************************************************************************/
/* symbols.c  -- see http://www.zeppoo.net                                    */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "zeppoo.h"

/* Thanks to c0de @ UNF <c0de@uskf.com> for lookup_root */
/* Get @ lookup_root */
unsigned long lookup_root(){
	int i;
	unsigned char buffer[4096];
	unsigned char proc_root[32];
  	unsigned long t = zepversion.kernel_start;
    
	while (t < zepversion.kernel_end) {
		zeppoo_read_memory(t, buffer, 4096);
      		for (i = 0; i < 4096; i++) {
			if(buffer[i] == PROC_ROOT_INO  && buffer[i+2] == PROC_ROOT_NOTHING && buffer[i+4] == PROC_ROOT_NAMELEN && buffer[i+12] == PROC_ROOT_MODE) {
					zeppoo_read_memory(t+i, proc_root, sizeof(proc_root));
				
					if(proc_root[16] == 0 && proc_root[20] == 0)
						return t+i;
			}
		}
		t+=4096;
	}
	return 0;
}

/* Get @ init_task */
/* proc_root => proc_root_operations => proc_root_readdir => proc_pid_readdir => get_tgid_list => init_task */
unsigned long zeppoo_find_init_task(void){
	unsigned char buffer[256];
	int i = 0;
	char *p;
	
	unsigned long proc_root, proc_root_operations, proc_root_readdir, proc_pid_readdir, get_tgid_list, init_task;

	proc_root = lookup_root();
#ifdef _DEBUG_	
	printf("proc_root @ 0x%x\n", (unsigned int)proc_root);
#endif
// < 2.6.15 + 32         >= 2.6.15 + 36
	if(zepversion.kernel >= 2.615 && zepversion.kernel < 2.616)
		zeppoo_read_memory(proc_root+36, &proc_root_operations, 4);
	else
		zeppoo_read_memory(proc_root+32, &proc_root_operations, 4);
		
#ifdef _DEBUG_
	printf("proc_root_operations @ 0x%x\n",(unsigned int)proc_root_operations);
#endif

	zeppoo_read_memory(proc_root_operations+24, &proc_root_readdir, 4);
#ifdef _DEBUG_
	printf("proc_root_readdir @ 0x%x\n",(unsigned int)proc_root_readdir);
#endif	

	zeppoo_read_memory(proc_root_readdir, buffer, 256);
	if((p = (char *)memmem(buffer, 256, zepversion.op_jmp, 1)) != NULL){
		i = (int)p - (int)buffer + 5;
		proc_pid_readdir = proc_root_readdir + *(unsigned long *)(p+1) + i + 5;
#ifdef _DEBUG_
		printf("proc_pid_readdir @ 0x%x\n",(unsigned int)proc_pid_readdir);
#endif				
	}

	zeppoo_read_memory(proc_pid_readdir, buffer, 256);
	if((p =(char *)memmem(buffer, 256, zepversion.op_call, 1)) != NULL){
		i = (int)p - (int)buffer + 5;	
		get_tgid_list = proc_pid_readdir + *(unsigned long *)(p+1) + i + 5;
#ifdef _DEBUG_
		printf("get_tgid_list @ 0x%x\n",(unsigned int)get_tgid_list);
#endif
	}
	

	zeppoo_read_memory(get_tgid_list, buffer, 256);
	if((p = (char *)memmem(buffer, 256, zepversion.op_cmp, 1)) != NULL){
		init_task = *(unsigned long *)(p+2);
#ifdef _DEBUG_
		printf("INIT_TASK @ 0x%x\n",(unsigned int)init_task);
#endif
	}

	return init_task;
}

