/******************************************************************************/
/* tasks.c  -- see http://www.zeppoo.net                                      */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "zeppoo.h"

void free_task(struct task *tmp){
        free(tmp);
}

/* Find offset to the next process */
int find_offset_next(char *buffer, size_t size){
        int i,offset,find1 = 0,find2 = 0;
        unsigned long first_addr,second_addr;

        for(i=0;i<size;i+=4){
//              printf("ADDR 0x%x 0x%x\n",*(unsigned long *)(buffer+i),i);
                second_addr = first_addr;
                first_addr = *(unsigned long *)(buffer+i);

                if((first_addr == second_addr) && (first_addr > ADDRMIN) && (i > 0x20)){
                        find2 = find1;
                        find1 = i;
 
//                      printf("ADDR1 0x%x ADDR2 0x%x\n",first_addr,second_addr);
                        if((find1-find2) == DIFFADDR){
#ifdef _DEBUG_                          
                                printf("POS = 0x%x\n",find2+JMPFIVEADDR);
#endif
                                offset = find2+JMPFIVEADDR;
                                return offset;	              
			}
                }
        }
        return 0;
}

int find_offset_name(char *buffer){
	char *p;

	p = (char *)memmem(buffer, 1024, "\x73\x77\x61\x70\x70\x65\x72", 7);
	
	return (int)p - (int)buffer;
}

int find_offset_list(char *buffer, int len){
	int i, count, offset;
	unsigned long first_addr, second_addr;
	count = 0;
	offset = -1;
	second_addr = -1;
	
	for(i=0;i<len && offset == -1;i+=4){
		first_addr = *(unsigned long *)(buffer+i);
		if(first_addr == second_addr)
			count++;
		if(count == 2){
			offset = i;
		}
		if(first_addr != 0)
			second_addr = first_addr;
	}
	return offset;
}

int find_offset_pid(char *buffer, int len){
	int i, offset;
	unsigned long first_addr, second_addr;
	
	
	offset = first_addr = second_addr = -1;

	for(i=0;i<len && offset == -1;i+=4){
		if(first_addr == 1)
			second_addr = first_addr;

		first_addr = *(unsigned long *)(buffer + i);
		if(first_addr == second_addr)
			offset = i;
	}

	return offset;
}

int find_offset_uid(char *buffer, int len){
	int offset, offset2;
	char *p;
	
	p = (char *)memmem(buffer, len, "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00", 28);

	offset = (int)p - (int)buffer;

	for(offset2 = 300; offset2<len; offset2+=4){
		p = (char *)memmem(buffer+offset2, len-offset2, "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00", 28);
		if(p == NULL)
			break;
	}

	if(offset2 <= 400)
		offset = offset2 - 8;
	
	return offset;
}

void zeppoo_init_taskInfo(void){
	char buffer[1024];
        unsigned long list_addr, current_addr;

        zeptaskinfo.init_task = zeppoo_find_init_task();
#ifdef _DEBUG_
        printf("GETTASKS INIT TASK @ 0x%x\n", (unsigned int)zeptaskinfo.init_task);
#endif

	zeppoo_fread_memory(zeptaskinfo.init_task, buffer, 1024);
        zeptaskinfo.offset_name = find_offset_name(buffer);
#ifdef _DEBUG_  
        printf("OFFSET NAME %d\n", zeptaskinfo.offset_name);
#endif

        zeppoo_fread_memory(zeptaskinfo.init_task+40, buffer, 100);
        zeptaskinfo.offset_list = find_offset_list(buffer, 100) + 20;
#ifdef _DEBUG_
        printf("OFFSET LIST %d\n", zeptaskinfo.offset_list);
#endif

        zeppoo_fread_memory(zeptaskinfo.init_task+zeptaskinfo.offset_list, &list_addr, 4);
        zeppoo_fread_memory(list_addr, buffer, 256);

        zeptaskinfo.offset_next = find_offset_next(buffer, 256);
#ifdef _DEBUG_
        printf("OFFSET NEXT %d\n", zeptaskinfo.offset_next);
#endif

        zeppoo_fread_memory(list_addr + zeptaskinfo.offset_next, &current_addr, 4);
	zeppoo_fread_memory(current_addr + zeptaskinfo.offset_list, buffer, 100);

        zeptaskinfo.offset_pid = find_offset_pid(buffer, 100);
        zeptaskinfo.offset_pid += zeptaskinfo.offset_list;
#ifdef _DEBUG_
        printf("OFFSET PID %d\n", zeptaskinfo.offset_pid);
#endif

        zeppoo_fread_memory(current_addr+zeptaskinfo.offset_pid, buffer, 500);
        zeptaskinfo.offset_uid = find_offset_uid(buffer, 500);
        zeptaskinfo.offset_uid += zeptaskinfo.offset_pid;
#ifdef _DEBUG_
        printf("OFFSET UID %d\n", zeptaskinfo.offset_uid);
#endif
	zeptaskinfo.first_addr = current_addr;
}

void zeppoo_get_tasks(ZHTable_t *mytasks){
        char name[16];
        char key[KEYSIZE];
        unsigned long list_addr, current_addr;
        int pid, uid, gid;
        struct task *current_task;

	  
        bzero(key, KEYSIZE);

	current_addr = zeptaskinfo.first_addr;
	do{
                zeppoo_fread_memory(current_addr + zeptaskinfo.offset_name, name, 16);
                zeppoo_fread_memory(current_addr + zeptaskinfo.offset_pid, &pid, 4);
                zeppoo_fread_memory(current_addr + zeptaskinfo.offset_uid, &uid, 4);
                zeppoo_fread_memory(current_addr + zeptaskinfo.offset_uid+16, &gid, 4);

                current_task = malloc(sizeof(struct task));
                snprintf(key, KEYSIZE, "%d",pid);
		bzero(current_task->name, sizeof(current_task->name));
                memcpy(current_task->name, name, sizeof(current_task->name));
                current_task->pid = pid;
                current_task->uid = uid;
                current_task->gid = gid;

                current_task->addr = current_addr;

                zeppoo_hash_insert(mytasks, key, KEYSIZE, current_task, (void *)free_task);

                bzero(key, KEYSIZE);
                zeppoo_fread_memory(current_addr + zeptaskinfo.offset_list, &list_addr, 4);
                zeppoo_fread_memory(list_addr + zeptaskinfo.offset_next, &current_addr, 4);
        }while(current_addr != zeptaskinfo.init_task);	
}

int zeppoo_get_task(int pid, struct task *rtask){
	char key[KEYSIZE];
	
	ZHTable_t *tasks;
	ZHash_t *htask;
	struct task *tmptask;
	int ret = -1;


	bzero(key, KEYSIZE);
	tasks = zeppoo_hash_new();
	zeppoo_get_tasks(tasks);

	snprintf(key, KEYSIZE, "%d", pid);
	htask =  (ZHash_t *)zeppoo_get_data(tasks, key, KEYSIZE);
	
	if(htask != NULL){
		tmptask = (struct task *)htask->value;
		memcpy(rtask->name, tmptask->name, sizeof(rtask->name));
		rtask->pid = tmptask->pid;
		rtask->uid = tmptask->uid;
		rtask->gid = tmptask->gid;
		rtask->addr = tmptask->addr;
		ret = 0;
	}
	
	zeppoo_hash_delete(tasks);
	return ret;
}
