/******************************************************************************/
/* version.c  -- see http://www.zeppoo.net                                    */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "zeppoo.h"

void deletedot(char *chaine, size_t len){
	int i,j;
	char kernel[len];
	i = j = 0;

	while(chaine[i] != '.'){
		kernel[j] = chaine[i];
		j++;
		i++;
	}
	kernel[j] = '.';
	j++;
	while(chaine[i] != '\0'){
		if(chaine[i] != '.'){
			kernel[j] = chaine[i];
			j++;
		}
		
		i++;
	}
	kernel[j] = '\0';
	memcpy(chaine, kernel, len);
	chaine[j] = '\0';
}	

void zeppoo_init_version(char *kernel, char *archi){
	if(kernel != NULL){
		deletedot(kernel, strlen(kernel));
		zepversion.kernel = atof(kernel);
	}
	else
		zepversion.kernel = 2.6;

	printf("Kernel : %.1f\n", zepversion.kernel);

	if(archi != NULL)
		memcpy(zepversion.archi, archi, sizeof(zepversion.archi));	
	else
		memcpy(zepversion.archi, "i386", sizeof(zepversion.archi));


	if(!strcmp(zepversion.archi, "amd64")){
		printf("Running on amd64\n");

	}
	else{
		printf("Running on i386 !!\n");
		zepversion.kernel_start = KERNEL_I386_START;
		zepversion.kernel_end = KERNEL_I386_END;

		memcpy(zepversion.op_jmp, OP_I386_JMP, sizeof(zepversion.op_jmp));
		memcpy(zepversion.op_call, OP_I386_CALL, sizeof(zepversion.op_call));
		memcpy(zepversion.op_cmp, OP_I386_CMP, sizeof(zepversion.op_cmp));
	}
}
