/******************************************************************************/
/* tasks.c  -- see http://www.zeppoo.net                                      */
/*                                                                            */
/* The project zeppoo is (C) 2006 : contact@zeppoo.net                        */
/* This program is free software;                                             */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* Version 2. This guarantees your right to use, modify, and                  */
/* redistribute this software under certain conditions.                       */
/*                                                                            */
/* Source is provided to this software because we believe users have a        */
/* right to know exactly what a program is going to do before they run        */
/* it.                                                                        */
/*                                                                            */
/* This program is distributed in the hope that it will be                    */
/* useful, but WITHOUT ANY WARRANTY; without even the implied                 */
/* warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR                    */
/* PURPOSE. See the GNU General Public License for more details (             */
/* http://www.gnu.org/copyleft/gpl.html ).                                    */
/*                                                                            */
/******************************************************************************/

#include "tasks.h"

void myfree_task(struct task *tmp){
	free(tmp);
}


void getTasksMemory(ZHTable_t *mytasks){
	zeppoo_init_taskInfo();
	zeppoo_get_tasks(mytasks);
}

/* Functions to get tasks by /proc */

int getOther(char *buffer, char *other, size_t lenbuffer, size_t lenother){
	char *ptr, *ptr2;
	size_t len;

	bzero(other, lenother);
	
	if((ptr = strstr(buffer,"\t")) != NULL){
        	ptr++;                                  
		if((ptr2 = strstr(buffer,"\n")) != NULL){	
			len = (int)ptr2 - (int)ptr;
			if(len < lenother){
				strncpy(other, ptr, len);
				other[lenother - 1] = '\0';
				return 0;
			}
		}
	}
	
	return -1;
}

int getUidGid(char *buffer, char *id, size_t lenbuffer, size_t lenid){
	char tmp[255];
	char *ptr,*ptr2;
	size_t len;

	bzero(id,lenid);

	if((ptr = strstr(buffer,"\t")) != NULL){
		ptr++;
						
		if((ptr2 = strstr(buffer,"\n")) != NULL){
			len = (int)ptr2 - (int)ptr;
			if(len < sizeof(tmp)){
				strncpy(tmp, ptr, len);
				tmp[sizeof(tmp) - 1] = '\0';

				if((ptr = strstr(tmp, "\t")) != NULL){
					len = (int)ptr - (int)tmp;

					if(len < lenid){
						strncpy(id, tmp, len);
						id[lenid - 1] = '\0';
						return 0;
					}
					
				}
			}
		}
	}
	return -1;
}

/* Get ALL Tasks by /proc */
int getInfo(char *file, ZHTable_t *mytasks, int rec) {
	FILE *output;
	char buffer[255];
	char name[16];
	char id[6];
	char key[KEYSIZE];

	struct task *current_task;

	bzero(key, KEYSIZE);
	
	if((output = fopen(file, "r")) == NULL){
		return -1;
	}
	else {
		while(fgets(buffer, 255, output) != NULL){
			if(!strncmp(buffer, "Name:", 5)){
				getOther(buffer, name, sizeof(buffer), sizeof(name));
				current_task = malloc(sizeof(struct task));
				
				memcpy(current_task->name, name , sizeof(current_task->name) - 1);
				current_task->name[sizeof(current_task->name) - 1] = '\0';

				current_task->rec = rec;
			}
			else if(!strncmp(buffer, "Pid:", 4)){
				getOther(buffer, id, sizeof(buffer), sizeof(id));
				current_task->pid = atoi(id);
			}
			else if(!strncmp(buffer, "Uid:", 4)){
				getUidGid(buffer, id, sizeof(buffer), sizeof(id));
				current_task->uid = atoi(id);
			}
			else if(!strncmp(buffer, "Gid:", 4)){
				getUidGid(buffer, id, sizeof(buffer), sizeof(id));
				current_task->gid = atoi(id);
			}
					
			bzero(buffer, 255);
		}
		snprintf(key, KEYSIZE, "%d", current_task->pid);
		current_task->addr = 0;
		zeppoo_hash_insert(mytasks, key, KEYSIZE, current_task, (void *)myfree_task);
		bzero(key, KEYSIZE);
	}
	fclose(output);
	return 0;
}

int getTasksProc(ZHTable_t *mytasks){
	DIR * dir, *rdir;
	struct dirent * entry, *rentry;
	char file[20];
	char directory[64];
	char rfile[64];

	if((dir = opendir("/proc")) == NULL){
		perror("opendir /proc :");
		return -1;
	}
	else{
		while((entry = readdir (dir)) != NULL){
			if(isdigit(entry->d_name[0]) != 0){
				bzero(file,20);
				snprintf(file, sizeof(file), "/proc/%s/status",entry->d_name);
				getInfo(file, mytasks, 0);

				snprintf(directory, sizeof(directory), "/proc/%s/task",entry->d_name);
				if((rdir = opendir(directory)) != NULL){
					while((rentry = readdir(rdir)) != NULL){
						if((isdigit(rentry->d_name[0]) != 0) && strcmp(entry->d_name,rentry->d_name)){
							snprintf(rfile, sizeof(rfile), "%s/%s/status",directory,rentry->d_name);
							getInfo(rfile, mytasks, 1);
						}
					}
					closedir(rdir);
				}
			}
		}
	}

	closedir(dir);
	
	return 0;
}


int getTasksProcForce(ZHTable_t *mytasks){
	int i;
	DIR * rdir;
	struct dirent * rentry;
	char file[20];
	char directory[64];
	char rfile[64];
	
	i = 1;
	while(i < 65535){
		bzero(file,20);
		snprintf(file, sizeof(file), "/proc/%d/status",i);
		
		if(getInfo(file, mytasks, 0) != -1){
			snprintf(directory, sizeof(directory), "/proc/%d/task",i);
			if((rdir = opendir(directory)) != NULL){
				while((rentry = readdir(rdir)) != NULL){
					if(((isdigit(rentry->d_name[0]) != 0)) && (atoi(rentry->d_name) != i)){
						snprintf(rfile, sizeof(rfile), "%s/%s/status",directory,rentry->d_name);
						getInfo(rfile, mytasks, 1);
					}
				}
				closedir(rdir);
			}
		}
		i ++;
	}
	
	printf("\n");
	return 0;
}


int getTasksPS(ZHTable_t *mytasks){ 
	FILE *output;
	char line[512];
	char key[KEYSIZE];
	int i = 0;
	char *p;
	struct task *current_task;

	bzero(key, KEYSIZE);
	
	if((output = popen("/bin/ps -eo user,pid,uid,gid,state,fname", "r")) == NULL){
		perror("popen :");
		return -1;
	}
	else{
		fgets(line, 512, output);
		while(fgets(line, 512, output) != NULL){
			i = 0;
			p = (char *)strtok(line, " ");
			while(p != NULL){
				switch (i) {
					case (0) :
						current_task = malloc(sizeof(struct task));
						break;
					case (1) :
						current_task->pid = atoi(p);
						break;
					case (2) :
						current_task->uid = atoi(p);
						break;
					case (3) :
						current_task->gid = atoi(p);
						break;
					case(5) :
						snprintf(current_task->name,sizeof(current_task->name),"%s",p);
						snprintf(key, KEYSIZE, "%d", current_task->pid); 
						current_task->addr = 0;      
						zeppoo_hash_insert(mytasks, key, 8, current_task, (void *)myfree_task);
						bzero(key, KEYSIZE);
						break;
				}

				p = (char *)strtok(NULL, " ");
				i++;
			}
				
		}
	}
	pclose(output);
	return 0;
}


int getTasksKill(ZHTable_t *mytasks){
	char key[KEYSIZE];
	int i;
	struct task *current_task;

	bzero(key, KEYSIZE);
	
	for(i=1; i<65535;i++){
		if(kill(i,0) == 0){
			current_task = malloc(sizeof(struct task));
			current_task->pid = i;
			current_task->addr = 0;
			snprintf(key, KEYSIZE, "%d", current_task->pid);
			zeppoo_hash_insert(mytasks, key, KEYSIZE, current_task, (void *)myfree_task); 
			bzero(key, KEYSIZE);
		}
	}
	return 0;
}

void checkTasks(ZHTable_t *ref, ZHTable_t *cmp, ZHTable_t *check){
	char key[KEYSIZE];
	struct Item_ZHTable * tmpRef;
	struct task *taskRef;
	struct task *taskCheck;
	
	ZHash_t * tmp;

	tmpRef = ref->first;
	while(tmpRef != NULL){
		taskRef = (struct task *)tmpRef->el->value;
		bzero(key, KEYSIZE);
		snprintf(key, KEYSIZE, "%d", taskRef->pid);

		tmp = (ZHash_t *)zeppoo_get_data(cmp, key, KEYSIZE);
		if(tmp == NULL && taskRef->rec == 0){
			taskCheck = malloc(sizeof(struct task));
			memcpy(taskCheck->name, taskRef->name, sizeof(taskCheck->name));
			taskCheck->pid = taskRef->pid;
			taskCheck->uid = taskRef->uid;
			taskCheck->gid = taskRef->gid;
			taskCheck->rec = taskRef->rec;
			taskCheck->addr = taskRef->addr;

			zeppoo_hash_insert(check, key, KEYSIZE, taskCheck, (void *)myfree_task);
			
		}
	
		tmpRef = tmpRef->next;
	}
}

void simpleViewTasks(ZHTable_t *mytasks){
        struct Item_ZHTable * tmp;
        struct task *tmptask;

        printf("PID\t UID\t GID\t NAME\t\t ADDR");

        tmp = mytasks->first;
        while(tmp != NULL){
                tmptask = (struct task *)tmp->el->value;
                printf("\n%d\t %d\t %d\t %-15s @ 0x%x", tmptask->pid, tmptask->uid, tmptask->gid, tmptask->name, (unsigned int)tmptask->addr);

                tmp = tmp->next;
        }

        printf("\n");

}

void viewCheckTasks(ZHTable_t *mytasks){
        struct Item_ZHTable * tmp;

        tmp = mytasks->first;
        if(tmp != NULL){
                printf("LIST OF HIDDEN TASKS\n");
                simpleViewTasks(mytasks);
        }
        else{
                printf("NO HIDDEN TASK\n");
                printf("YOUR SYSTEM SEEMS TO BE SAFE !\n");
        }

}

void viewTasksMemory(void){
	ZHTable_t *tasksmemory;
	tasksmemory = zeppoo_hash_new();

	getTasksMemory(tasksmemory);
	simpleViewTasks(tasksmemory);	
	
	zeppoo_hash_delete(tasksmemory);
}

void viewTaskMemory(int pid){
	struct task ptask;
	
	zeppoo_init_taskInfo();
	if(!zeppoo_get_task(pid, &ptask)){
		printf("PID\t UID\t GID\t NAME\t\t ADDR");
		printf("\n%d\t %d\t %d\t %-15s @ 0x%x\n", ptask.pid, ptask.uid, ptask.gid, ptask.name, (unsigned int)ptask.addr);
	}
	else
		printf("Task %d not found !\n", pid);
}

void viewHiddenTasks(void){
	ZHTable_t *tasksmemory;
	ZHTable_t *tasksproc;
	ZHTable_t *tasksprocforce;
	ZHTable_t *tasksps;
	ZHTable_t *taskskill;
	ZHTable_t *taskscheck;
	
	tasksmemory = zeppoo_hash_new();
	tasksproc = zeppoo_hash_new();
	tasksprocforce = zeppoo_hash_new();
    	tasksps = zeppoo_hash_new();
	taskskill = zeppoo_hash_new();
	taskscheck = zeppoo_hash_new();
	
	getTasksMemory(tasksmemory);
	getTasksProc(tasksproc);
	getTasksProcForce(tasksprocforce);
	getTasksPS(tasksps);
	getTasksKill(taskskill);
		
	checkTasks(tasksproc, tasksps, taskscheck);
	checkTasks(tasksprocforce, tasksproc, taskscheck);
	checkTasks(tasksmemory, tasksproc, taskscheck);
	checkTasks(taskskill, tasksproc, taskscheck);
	viewCheckTasks(taskscheck);
	
	zeppoo_hash_delete(tasksmemory);
	zeppoo_hash_delete(tasksproc);
	zeppoo_hash_delete(tasksprocforce);
	zeppoo_hash_delete(tasksps);
	zeppoo_hash_delete(taskskill);
	zeppoo_hash_delete(taskscheck);
}
